dofile "lib/dream9.lua"

function jpg(s) 
  return const.path.gfx.."0-prolog/escape/"..s..".jpg"; 
end

escape = engine.state {
   _life        = 100 --Kate life meter
  ,_extin       = false --Kate took extinguisher
  ,_extinused   = false --Kate used extinguisher to extinguish fire
  ,_restroom    = false --Kate opened restroom
}

escape_player = musplayer.player {
   mus("edgeofdeath"):inside("start"):loop()
  ,mute():inside("wayback")
  ,mus("fire"):inside("wayback"):loop()
  ,mute():inside("wayback_success")
  ,sfx("extin"):inside("wayback_success")
  ,mus("burning"):inside("coridor2"):when("escape._extinused"):loop()
  ,sfx("explosion"):inside("blow1")
  ,sfx("dizzy"):inside("dizziness")
  ,sfx("dizzy"):inside("death_smoke")
  ,sfx("charge"):inside("death_fire")
  ,mute():inside("span2")
  ,mus("fire"):inside("end2"):loop()
  ,mute():inside("end3")
  ,sfx("bam"):inside("end3")
}

main = engine.main {
   start        = chain_ {
                     episode_("0-escape")
                    ,musplayer_("escape_player")
                    ,event_("smokedeath")
                    ,walk_("start")
                  }
  ,finish       = chain_ {
                     unevent_("smokedeath")
                    ,gamefile_("1-deadhour/wake.lua")
                  }
}

smokedeath = event {
  invoke        = function(s)
                    if escape._life == 0 then
                      walk("death_smoke");
                    end
                    escape._life = escape._life - 1;
                  end
}

extin = takeitem {
   nam          = choose_ {
                     ["default"] = "Огнетушитель"
                    ,["escape._extinused"] = "Пустой огнетушитель"
                  }
  ,dsc          = "На стене висит {огнетушитель}."
  ,tak          = "Катя сняла со стены огнетушитель."
  ,act          = set_("escape._extin")
  ,ico          = ico "extinguisher"
  ,img          = ico "extinguisher-use"
  ,inf          = choose_ {
                     ["default"] = "Стандартный огнетушитель"
                    ,["escape._extinused"] = "Пустой огнетушитель"
                  }
  ,use          = chooseuse_ {
                     ["default"] = "Наверняка можно найти лучшее применение для огнетушителя."
                    ,["restroom_door"] =  choose_ {
                                             ["default"] = chain_ { sound_("smashextin"), set_("escape._restroom"), walk_("restroom"), "Катя выбила дверь огнетушителем." }
                                            ,["escape._restroom"] = "Замки уже сбиты, дверь можно просто открыть."
                                          }
                    ,["coridor_fire"] = "Вряд ли можно потушить огонь пустым огнетушителем."
                    ,["wayback_fire"] = walk_("wayback_success")
                    ,["sylo1_door"] = "Какой смысл пытаться выбить незакрытую дверь?"
                    ,["sylo2_door"] = chain_ { sound_("smashextin"), "Дверь никак не получается выбить, такое впечатление, что она завалена чем-то с другой стороны." }
                    ,["exit_door"] = chain_ { sound_("smashextin"), walk_("end1") }
                  }
}

start = cutscene {
   img          = jpg "entrance1"
  ,dsc          = [[Здание все еще сотрясается от взрывов. Кажется, что пол под ногами может обвалиться в любую секунду.
                    К тому же весь воздух вокруг пропитан тяжелым и едким дымом, Катя едва может дышать. Она не протянет так долго, надо искать выход.]]
  ,next         = "coridor1"
}

coridor1 = scene {
   img          = jpg "entrance1"
  ,obj          = { "restroom_door" }
  ,nav          = {
                    up = vw("В конец коридора", "coridor2")
                  }
}

restroom_door = staticitem {
   dsc          = "Справа едва виднеется какая-то {дверь}."
  ,act          = choose_ {
                     ["default"] = chain_{ sound_("doorclosed"), "Дверь закрыта. Катя попробовала толкнуть дверь плечом, но ничего не получилось." }
                    ,["escape._restroom"] = walk_("restroom")
                  }
}

restroom = scene {
   img          = choose_{
                     ["default"] = jpg "restroom_spray"
                    ,["inventory.has(spray)"] = jpg "restroom"
                  }
  ,alwaysdsc    = true
  ,dsc          = [[Похоже, этой уборной давно уже никто не пользовался. Раковина вся покрыта грязью,
                    а трубы у смывного бачка пожелтели от ржавчины. Воды здесь явно нет.]]
  ,obj          = { "spray" }
  ,nav          = { down = vw("Выйти из уборной", "coridor1") }
}

spray = takeitem {
   nam          = "Лак для волос"
  ,dsc          = "В шкафчике на стене стоит цветастый балончик. Похоже, это {лак для волос}."
  ,tak          = "Катя взяла лак для волос из шкафчика. Судя по весу, он полный."
  ,ico          = ico "spray"
  ,img          = ico "spray-use"
  ,inf          = "Балончик с лаком для волос. Судя по весу, полный."
  ,use          = chooseuse_ {
                     ["default"] = "В этом нет никакого смысла."
                    ,["coridor_fire"] = chain_ { drop_("spray"), walk_("blow1") }
                  }
}

coridor2 = scene {
   img          = jpg "entrance2"
  ,obj          = { "coridor_fire" }
  ,nav          = {
                     up = fake_vw("В конец коридора", "Здесь невозможно пройти.")
                    ,down = vw("В начало коридора", "coridor1")
                    ,left = vw("В комнату налево", "debris1")
                  }
}

coridor_fire = staticitem {
   dsc          = [[Вперед пройти не получится, {огонь} слишком сильный. Надо найти способ перебраться на другую сторону -- или обходной путь.]]
  ,act          = "Если бы можно было чем-то потушить огонь, то Катя смогла бы здесь пройти."
}

debris1 = scene {
   img          = choose_ {
                     ["default"] = jpg "debris1_nofire"
                    ,["escape._extin"] = jpg "debris1"
                  }
  ,dsc          = choose_ {
                     ["default"] = nil
                    ,["escape._extin"] = "Огонь снова разгорелся. Здесь теперь не пройти."
                  }
  ,alwaysdsc    = true
  ,nav          = {
                     up = vw("В конец комнаты", "debris2")
                    ,down = vw("В основной коридор", "coridor2")
                  }
}

debris2 = scene {
   img          = choose_ {
                     ["default"] = jpg "debris2_extin"
                    ,["escape._extin"] = jpg "debris2"
                  }
  ,nav          = {
                     up = vw("К двери", "span")
                    ,down = vw("В центр комнаты", "debris1")
                  }
}

span = scene {
   img          = choose_ {
                     ["default"] = jpg "span_extin"
                    ,["escape._extin"] = jpg "span"
                  }
  ,obj          = { "extin", "sylo1_door", "sylo2_door" }
  ,nav          = { 
                    down = vw("Вернуться назад", "wayback")
                  }
}

sylo1_door = staticitem {
   dsc          = "{Слева} и"
  ,act          = walk_("sylo1")
}

sylo2_door = staticitem {
   dsc          = "{справа} от Кати -- закрытые двери."
  ,act          = chain_{ sound_("doorclosed"), "Дверь не открывается." }
}

sylo1 = scene {
   img          = jpg "sylo"
  ,dsc          = "Судя по всему, это обычное складское помещение."
  ,obj          = { "ladder" }
  ,nav          = { right = vw("Выйти из комнаты", "span") }
}

ladder = staticitem {
   dsc          = "У шкафа стоит высокая {стремянка}, которая едва не касается потолка."
  ,act          = "Лестница слишком тяжелая, чтобы Катя смогла ее унести."
}

wayback = scene {
   img          = jpg "wayback"
  ,obj          = { "wayback_fire" }
  ,nav          = {
                     up = fake_vw("В основной коридор", "Через огонь не пройти.")
                    ,down = vw("Отступить", "span")
                  }
}

wayback_success = cutscene {
   img          = jpg "wayback_nofire"
  ,dsc          = [[Катя несколько минут поливала огонь кипящей пеной, пока огнетушитель не издал надрывный хрип и не замолк. 
                    Проход был пока свободен, однако пламя вокруг быстро начинало разгораться вновь.]]
  ,enter        = set_("escape._extinused")
  ,next         = "coridor2"
}

wayback_fire = staticitem {
   dsc          = "Здесь больше не пройти. Все кругом застилает {огонь}."
  ,act          = "Кажется, горит какой-то газ. От дыма начинает кружиться голова и слезиться в глазах."
}

blow1 = tremor {
   fps          = 45
  ,shift        = 16
  ,img          = jpg "blow"
  ,next         = "blow2"
}

blow2 = cutscene {
   img          = jpg "blow"
  ,dsc          = [[Взрыв был неожиданно сильный. Катя едва успела отпрыгнуть. С потолка на нее посыпалась штукатурка. 
                    Что-то за ее спиной с грохотом обвалилось.]]
  ,next         = "bridge"
}

bridge = scene {
   img          = jpg "bridge"
  ,dsc          = "Потолочные панели осыпались и немного притушили пламя. Теперь Катя может попробовать пройти здесь."
  ,nav          = { up = vw("Перебраться через дыру", "coridor3") }
}

coridor3 = scene {
   img          = jpg "entrance3"
  ,dsc          = "Все вокруг застилает едким дымом. Кате все сложнее дышать."
  ,obj          = { "coridor_door2" }
  ,nav          = { left = vw("В комнату налево", "deadend1") }
}

deadend1 = scene {
   img          = jpg "deadend1"
  ,nav          = {
                     up = vw("В конец комнаты", "deadend2_hub")
                    ,down = vw("В коридор", "coridor3")
                  }
}

deadend2_hub = engine.hub {
  enter         = choose_ {
                     ["default"] = walk_("dizziness")
                    ,["deadend2_hub._seen"] = walk_("deadend2")
                  }
}

dizziness = dizzy {
   fps          = 10
  ,shift        = 32
  ,step         = 4
  ,img          = jpg "deadend1"
  ,bg           = jpg "deadend1"
  ,next         = "deadend1_scene"
}

deadend1_scene = cutscene {
   img          = jpg "deadend1"
  ,dsc          = [[Катя едва стоит на ногах. Быть может, ее оглушило при взрыве или во всем виноват
                    этот дым, который разъедает легкие? Она чувствует -- еще немного, и она потеряет
                    сознание.]]
  ,next         = "deadend1"
}

deadend2 = scene {
   img          = jpg "deadend2"
  ,dsc          = "Здесь тупик."
  ,nav          = {
                    down = vw("Вернуться назад", "deadend1")
                  }
}

coridor_door2 = staticitem {
   dsc          = choose_ {
                     ["default"] = "Она даже не сразу замечает {дверь} справа."
                    ,["coridor3._seen"] = "Справа от Кати -- {незакрытая} дверь."
                  }
  ,act          = walk_("span2")
}

span2 = scene {
   img          = jpg "span2"
  ,dsc          = "Еще одна комната. Здесь хотя ,бы не так много дыма."
  ,obj          = { "death_door", "exit_door" }
  ,nav          = { down = vw("Выйти в коридор", "coridor3") }
}

exit_door = staticitem {
   dsc          = "Справа тоже есть {дверь}. Выбор невелик."
  ,act          = chain_ { sound_("doorclosed"), "Дверь закрыта." }
}

death_door = staticitem {
   dsc          = "{Дверь слева} как-то странно искорежена и, кажется, вот-вот слетит с петель. Как будто ее едва не вынесло взрывной волной."
  ,act          = walk_("death_fire")
}

death_fire = cutscene {
   img          = jpg "doorblow"
  ,dsc          = [[Стоило Кате потянуть на себя дверную ручку, как дверь страшно задрожала, слетела с петель, и из дверного проема 
                    вырвался огромный столп огня. Она ничего не успела сделать.]]
  ,next         = "gameover"
}

death_smoke = cutscene {
   img          = jpg "death"
  ,dsc          = [[У Кати больше не было сил. Едкий черный дым застилал все вокруг, у нее не получалось даже вздохнуть. Катя оступилась,
                    упала и больше уже не смогла встать.]]
  ,next         = "gameover"
}

end1 = pause {
   time         = 1500
  ,next         = "end2"
}

end2 = cutscene {
   img          = jpg "ani1"
  ,dsc          = [[Пола под ногами почти не было. Весь этаж обвалился. Повсюду полыхало пламя.]]
  ,next         = "ani"
}

ani = animation {
   fps          = 2
  ,frames       = {
                     jpg "ani1"
                    ,jpg "ani2"
                    ,jpg "ani3"
                    ,jpg "ani4"
                    ,jpg "ani5"
                    ,jpg "ani6"
                    ,jpg "ani7"
                  }
  ,next         = "end3"
}

end3 = anitext.title {
   time         = 5000
  ,title        = "РАДИКАЛ"
  ,fontsize     = 56
  ,next         = "main"
}