dofile "lib/dream9.lua"

function jpg(s) 
  return const.path.gfx.."1-deadhour/clinic/"..s..".jpg"; 
end

function dxml(s)
  return const.path.dlg.."1-deadhour/clinic/"..s..".xml";
end

main = engine.main {
   start        = chain_ {
                     episode_("1-clinic")
                    ,musplayer_("clinic_player")
                    ,walk_("hall1")
                  }
  ,finish       = gamefile_("1-deadhour/tea.lua")
}

clinic = engine.state {
   _steps       = 0     --Number of Kate steps in waiting hall
  ,_ready       = false --Kate is ready to go to Tikhonov
  ,_alldone     = false --All is done here
}

clinic_player = musplayer.player {
  mus("jitters"):inside("hall1")
}

hall1 = scene {
   img          = jpg "hall1"
  ,obj          = { "dad", "clinicman" }
  ,enter        = choose_ {
                     ["default"] = inc_("clinic._steps")
                    ,["clinic._steps==10"] = chain_ { inc_("clinic._steps"), popup_("Кате кажется, что они с отцом ждут здесь уже больше часа, а доктор так и не вызывает к себе,^хотя у него нет сейчас посетителей.") }
                    ,["clinic._steps>=20 and not clinic._ready"] = walk_("flash")
                  }
  ,nav          = {
                     up = vw("В кабинет доктора Тихонова", "cabinet", "clinic._ready", "Доктор Тихонов должен сначала вызвать к себе.")
                    ,right = vw("В другую часть зала ожидания", "hall2")
                  }
}

dad = staticitem {
   dsc          = "Хотя {отец} и уверяет Катю, что чувствует себя хорошо, видно, что он держится из последних сил."
  ,act          = walk_("dad_dlg")
}

dad_dlg = dialog {
   nam          = "Отец"
  ,dsc          = "Отец старается не показывать, как ему плохо."
  ,img          = npc "katedad"
  ,dlg          = dxml "dad"
}

clinicman = staticitem {
   dsc          = "Рядом с отцом, на диване, сидит {молодой мужчина} -- он занимал за ними очередь к доктору Тихонову."
  ,act          = walk_("clinicman_dlg")
}

clinicman_dlg = dialog {
   img          = npc "clinicman"
  ,dsc          = "У мужчины странное раздражение на коже -- то ли ожог, то ли экзема."
  ,dlg          = dxml "clinicman"
}

hall2 = scene {
   img          = jpg "hall2"
  ,enter        = choose_ {
                     ["default"] = inc_("clinic._steps")
                    ,["clinic._steps==10"] = chain_ { inc_("clinic._steps"), popup_("Кате кажется, что они с отцом ждут здесь уже больше часа, а доктор так и не вызывает к себе,^хотя у него нет сейчас посетителей.") }
                  }
  ,obj          = { "infopaper" }
  ,nav          = {
                    left = vw("В другую часть зала ожидания", "hall1")
                  }
}

infopaper = staticitem {
   dsc          = "На доске висит какое-то {объявление}."
  ,act          = walk_("infopaper_room")
}

infopaper_room = itemroom {
   inf          = "Это просто реклама платного онкологического обследования."
  ,img          = itm "infopaper4"
}

cabinet = scene {
   img          = jpg "cabinet"
  ,obj          = { "tikhonov" }
  ,nav          = {
                    right = vw("Выйти", "main", "clinic._alldone", "Не стоит сейчас уходить. Надо сначала поговорить с доктором.")
                  }
}

tikhonov = staticitem {
   dsc          = "{Доктор Тихонов} стоит рядом со странным старым креслом, похожим на какое-то пыточное приспособление."
  ,act          = walk_("tikhonov_dlg")
}

tikhonov_dlg = dialog {
   nam          = "Доктор Тихонов"
  ,dsc          = "-- Здравствуйте, присаживайтесь..."
  ,img          = npc "tikhonov"
  ,dlg          = dxml "tikhonov"
}

flash = animation {
   fps          = 2
  ,enter        = set_("clinic._ready")
  ,frames       = {
                     jpg "door1"
                    ,jpg "door2"
                    ,jpg "door1"
                    ,jpg "door2"
                    ,jpg "door1"
                    ,jpg "door2"
                    ,jpg "door1"
                    ,jpg "door2"
                    ,jpg "door1"
                  }
  ,next         = "hall1"
}