dofile "lib/dream9.lua"

function jpg(s) 
  return const.path.gfx.."1-deadhour/institute/"..s..".jpg"; 
end

function dxml(s)
  return const.path.dlg.."1-deadhour/institute/"..s..".xml";
end

main = engine.main {
   start        = chain_ {
                     episode_("1-institute")
                    ,musplayer_("institute_player")
                    ,walk_("entrance")
                  }
  ,finish       = gamefile_("1-deadhour/subway.lua")
}

institute = engine.state {
   _sawphoto    = false --Kate saw Kochevnikov photo
  ,_board       = false --Kate looked at the board at first time
  ,_spoken      = false --Kate has spoken with receptionist
}

institute_player = musplayer.player {
   sfx("note"):inside("entrance")
  ,mus("dad"):inside("entrance"):when("institute._spoken")
  ,mute():fade(3000,3000):inside("doctor")
  ,sfx("note"):inside("street_transfer")
  ,mus("lotus"):inside("street1")
}

entrance = scene {
   img          = jpg "entrance"
  ,dsc          = [[Это был уже второй институт онкологии, в который приехала Катя. Она долго стояла у дверей, не решаясь подойти к ресепшену.
                    Обстановка внутри была не похожа ни на одно из медицинских учреждений, в которых бывала Катя.]]
  ,nav          = {
                     up = vw("К лифту", "elevator")
                    ,down = fake_vw("На улицу", "Пока еще рано уходить.")
                    ,right = vw("В секцию для гостей", "guestroom")
                    ,left = vw("К ресепшину", "reception")
                  }
}

reception = scene {
   img          = jpg "reception"
  ,obj          = { "instituteclerk" }
  ,nav          = {
                    down = vw("Вернуться", "entrance")
                  }
}

instituteclerk = staticitem {
   dsc          = "За стойкой сидит {мужчина} в светлом пиджаке."
  ,act          = walk_("instituteclerk_dlg")
}

instituteclerk_dlg = dialog {
   img          = npc "instituteclerk"
  ,dsc          = "Ему явно нечем себя занять."
  ,dlg          = dxml "instituteclerk"
}

elevator = scene {
   img          = jpg "elevator"
  ,obj          = { "board" }
  ,nav          = {
                     up = vw("В лифт", "instituteclerk_dlg2")
                    ,down = vw("Вернуться", "entrance")
                  }
}

board = staticitem {
   dsc          = choose_ {
                     ["default"] = "На стене висит {доска} с какими-то объявлениями."
                    ,["institute._board"] = "На доске с объявлениями можно заметить какие-то приказы, отпечатанные на скверной желтоватой бумаге, и {вырезку} из старой газеты."
                  }
  ,act          = choose_ {
                     ["default"] = chain_ { set_("institute._board"), "На доске - множество объявлений и вырезка из старой газеты." }
                    ,["institute._board"] = chain_ { set_("institute._sawphoto"), walk_("board_room") }
                  }
}

board_room = itemroom {
   img          = itm "newspaper"
  ,inf          = choose_ {
                    ["institute._board"] = "Вырезка из газеты с фотографией Кочевникова."
                  }
}

instituteclerk_dlg2 = dialog {
   img          = npc "instituteclerk"
  ,dsc          = choose_ {
                     ["default"] = "-- Девушка, а вы к кому?"
                    ,["institute._spoken"] = "-- Девушка, куда вы собрались? Я же говорил вам, что не могу вас пропустить."
                  }
  ,dlg          = dxml "instituteclerk2"
}

guestroom = scene {
   img          = jpg "waitroom"
  ,obj          = { "waititem" }
  ,nav          = {
                    down = vw("Вернуться", "entrance")
                  }
}

waititem = staticitem {
   dsc          = choose_ {
                     ["default"] = ""
                    ,["institute._spoken"] = "Катя думает, что действительно могла бы подождать здесь Кочевникова, но ведь она даже не знает, как он выглядит."
                    ,["institute._spoken and institute._sawphoto"] = "Кате ничего не остается, как {ждать}, когда спустится Кочевников."
                  }
  ,act          = walk_("waitevent")
}

waitevent = pause {
   time         = 3000
  ,fading       = 50
  ,next         = "doctor"
}

doctor = scene {
   img          = jpg "doctor"
  ,obj          = { "kochevnikov" }
}

kochevnikov = staticitem {
   dsc          = "Спустя несколько часов {Кочевников} наконец вышел лифта и быстро зашагал к выходу из здания."
  ,act          = walk_("kochevnikov_dlg")
}

kochevnikov_dlg = dialog {
   nam          = "Доктор Кочевников"
  ,img          = npc "kochevnikov"
  ,dlg          = dxml "kochevnikov"
}

street_transfer = pause {
   time         = 5000
  ,next         = "street1"
}

street1 = scene {
   img          = jpg "street1"
  ,dsc          = [[Начался дождь, и стало темно, как поздним вечером. В лицо Кате дул порывистый холодный ветер. Катя вдруг подумала,
                    что, хотя еще на исходе август, лето уже давно завершилось, и во всем этом промозглом городе чувствуется
                    неумолимое приближение зимы. 
                    ^Куртка Кати насквозь промолка от дождя.]]
  ,nav          = {
                    up = vw("К метро", "street2")
                  }
}

street2 = scene {
   img          = jpg "street2"
  ,dsc          = [[Людей на улице совсем не было, как будто комендантский час давно уже начался. Катя невольно оглядывалась по сторонам, 
                    ожидая в любую минуту увидеть полицейский патруль
                    или зависшее над тротуаром око, как если бы ее старенькие электронные часы вдруг начали своенравно перевирать
                    время, скрывая от нее то, что на город уже опустилась глубокая ночь.]]
  ,nav          = {
                     up = vw("К метро", "street3")
                    ,down = vw("К институту", "street1")
                  }
}

street3 = scene {
   img          = jpg "street3"
  ,nav          = {
                     up = vw("К метро", "street4")
                    ,down = vw("К институту", "street2")
                  }
}

street4 = scene {
   img          = jpg "street4"
  ,dsc          = [[На секунду Кате показалось, что она идет совсем не в ту сторону, но потом она вспомнила, что уже проходила здесь,
                    когда искала институт. Метро было уже совсем недалеко.]]
  ,nav          = {
                     up = vw("К метро", "main")
                    ,down = vw("К институту", "street3")
                  }
}