dofile "lib/dream9.lua"

function jpg(s) 
  return const.path.gfx.."1-deadhour/med/"..s..".jpg"; 
end

function dxml(s)
  return const.path.dlg.."1-deadhour/med/"..s..".xml";
end

main = engine.main {
   start        = chain_ {
                     episode_("1-med")
                    ,musplayer_("med_player")
                    ,walk_("floor8_coridor1")
                  }
  ,finish       = gamefile_("1-deadhour/institute.lua")
}

med = engine.state {
   _elevator    = nil   --Transfer
  ,_nodoctor    = false --Doctor is not in his room
  ,_info        = false --Kate read the info on a wall
  ,_paper       = false --Kate found a peace of paper
  ,_floor2      = false --Kate was told to go to the 2nd floor
  ,_alldone     = false --All quests are done
}

med_player = musplayer.player {
   sfx("elevator"):inside("medtransfer"):always()
  ,mus("hospitalsounds"):inside("floor8_coridor1"):loop():always()
  ,mute():fade(3000,3000):inside("floor8_elevator"):always()
  ,mus("lotus"):inside("floor1_hall"):always()
  ,mus("lotus"):inside("floor2_coridor"):always()
  ,mute():fade(3000,3000):inside("floor14"):always()
}

medtransfer = pause {
   time         = 1800
  ,next         = "medshuffle"
}

medshuffle = tremor {
   fps          = 40
  ,shift        = 16
  ,img          = jpg "elevator_shaft"
  ,next         = function() walk(med._elevator) end
}

floor1_shaft = dialog {
   bg           = jpg "elevator_shaft"
  ,nomask       = true
  ,dlg          = dxml "elevator1"
}

floor1_elevator = scene {
   img          = jpg "hall_elevator"
  ,nav          = {
                     up = vw("В лифт", "floor1_shaft")
                    ,down = vw("В фое", "floor1_hall")
                  }
}

floor1_hall = scene {
   img          = choose_ {
                     ["default"] = jpg "hall_paper"
                    ,["med._paper"] = jpg "hall"
                  }
  ,obj          = { "meddoc", "infopaper2" }
  ,nav          = {
                     right = fake_vw("На улицу", "Пока еще рано уходить.")
                    ,down = vw("К лифту", "floor1_elevator")
                  }
}

infopaper2 = staticitem {
   dsc          = "На полу перед Катей валяется {клочок бумаги}."
  ,cnd          = not_("med._paper")
  ,act          = chain_ { set_("med._paper"), walk_("infopaper2_room") }
}

infopaper2_room = itemroom {
   img          = itm "infopaper2"
  ,inf          = choose_ {
                     ["default"] = "Какой-то номер. Не совсем понятно, что он означает."
                    ,["med._info"] = "Похоже, что это обрывок от объявление у кабинета Кочевникова. Скорее всего, в объявлении говорится, что по срочным вопросам нужно обращаться в этот кабинет."
                  }
}

meddoc = staticitem {
   dsc          = "За стойкой, у компьютера, сидит {мужчина} в белом халате, похожий на доктора."
  ,act          = walk_("meddoc_dlg")
}

meddoc_dlg = dialog {
   img          = npc "meddoc"
  ,dsc          = "Мужчина явно устал от постоянных распросов."
  ,dlg          = dxml "meddoc"
  ,talkend      = "floor1_hall"
}

floor2_shaft = dialog {
   bg           = jpg "elevator_shaft"
  ,nomask       = true
  ,dlg          = dxml "elevator2"
}

floor2_elevator = scene {
   img          = jpg "floor8_elevator"
  ,nav          = {
                     up = vw("В лифт", "floor2_shaft")
                    ,down = vw("В коридор", "floor2_coridor")
                  }
}

floor2_coridor = scene {
   img          = jpg "floor2"
  ,dsc          = "Катя точно не знает, куда нужно идти. Она начинает сомневаться в том, что здесь ей действительно помогут."
  ,nav          = {
                     up = vw("В бухгалтерию", "floor2_cabinet")
                    ,down = vw("К лифту", "floor2_elevator")
                  }
}

floor2_cabinet = scene {
   img          = jpg "floor2_cabinet"
  ,obj          = { "medclerk" }
  ,nav          = {
                    down = vw("В коридор", "floor2_coridor")
                  }
}

medclerk = staticitem {
   dsc          = "Похоже, именно здесь находится бухгалтерия медицинского центра. Однако из всех сотрудников на месте только {один} -- небритый мужчина, который делает вид, что погружен в работу."
  ,act          = walk_("medclerk_dlg")
}

medclerk_dlg = dialog {
   img          = npc "medclerk"
  ,dsc          = "Мужчина делает вид, что не замечает Анну."
  ,dlg          = dxml "medclerk"
}

floor8_shaft = dialog {
   bg           = jpg "elevator_shaft"
  ,nomask       = true
  ,dlg          = dxml "elevator8"
}

floor8_elevator = scene {
   img          = jpg "floor8_elevator"
  ,nav          = {
                     up = vw("В лифт", "floor8_shaft")
                    ,down = vw("В коридор", "floor8_coridor1")
                  }
}

floor8_coridor1 = scene {
   img          = choose_ {
                     ["default"] = jpg "floor8_coridor1a"
                    ,["med._paper"] = jpg "floor8_coridor1b"
                  }
  ,obj          = { "doctor" }
  ,nav          = {
                     up = vw("В конец коридора", "floor8_coridor2")
                    ,down = vw("К лифту", "floor8_elevator")
                  }
}

doctor = staticitem {
   dsc          = "На этом этаже довольно шумно. {Доктор} в помятом белом халате что-то возмущенно объясняет пожилому посетителю."
  ,cnd          = not_("med._paper")
  ,act          = "Он слишком занят сейчас."
}

floor8_coridor2 = scene {
   img          = choose_ {
                     ["default"] = jpg "floor8_coridor2a"
                    ,["med._paper"] = jpg "floor8_coridor2b"
                  }
  ,obj          = { "medman", "medgirl", "medold", "infopaper" }
  ,nav          = {
                     left  = fake_vw("Кабинет 804", "Доктор Петров. Кате сюда не нужно. К тому же, судя по всему, в этот кабинет большая очередь.")
                    ,right = fake_vw("Кабинет 805", chain_ { sound_("doorclosed"), set_("med._nodoctor"), "Дверь закрыта." })
                    ,down = vw("В начало коридора", "floor8_coridor1")
                  }
}

infopaper = staticitem {
   dsc          = "На стене под лампой висит обрывок какого-то {объявления}."
  ,act          = chain_ { set_("med._info"), walk_("infopaper_room") }
}

infopaper_room = itemroom {
   img          = itm "infopaper"
  ,inf          = choose_ {
                     ["default"] = "Судя по всему, недовольные посетители оторвали часть объявления. В любом случае, и так понятно, что доктора Кочевникова сегодня не будет."
                    ,["med._paper"] = "Видимо, обрывок бумаги, который Катя нашла в фое, был от этого объявления. Скорее всего, в объявлении говорится, что по срочным вопросам нужно обращаться в 1412 кабинет."
                  }
}

medold = staticitem {
   dsc          = "{Старик} напротив нее, кажется, с трудом борется со сном."
  ,act          = "Лучше его не беспокоить."
}

medman = staticitem {
   dsc          = "В кресле, спиной к Кате, сидит молодой {мужчина}."
  ,act          = walk_("medman_dlg")
}

medman_dlg = dialog {
   img          = npc "medman"
  ,dsc          = "Мужчина даже не поворачивается к Кате."
  ,dlg          = dxml "medman"
}

medgirl = staticitem {
   dsc          = "Рядом с дверью в кабинет доктора Кочевникова стоит {девушка} в мятой куртке и джинсах."
  ,act          = walk_("medgirl_dlg")
}

medgirl_dlg = dialog {
   img          = npc "medgirl"
  ,dsc          = "Девушка выглядит сильно уставшей, как будто стоит здесь в очереди уже не первый день."
  ,dlg          = dxml "medgirl"
}

floor14_shaft = dialog {
   bg           = jpg "elevator_shaft"
  ,nomask       = true
  ,dlg          = dxml "elevator14"
}

floor14 = scene {
   img          = jpg "floor14"
  ,nav          = {
                     left = vw("В лифт", "floor14_shaft")
                    ,up = vw("Кабинет 1412", "floor14_room")
                  }
}

floor14_room = scene {
   img          = jpg "1412"
  ,obj          = { "kirillov" }
  ,nav          = {
                    down = vw("Выйти в коридор", "floor14_hub")
                  }
}

kirillov = staticitem {
   dsc          = "За столом сидит {пожилой мужчина}. Наверное, это доктор Кириллов."
  ,act          = walk_("kirillov_dlg")
}

kirillov_dlg = dialog {
   nam          = "Доктор Кириллов"
  ,img          = npc "kirillov"
  ,dsc          = choose_ {
                     ["default"] = "-- Да, да. Я вас слушаю."
                    ,["med._alldone"] = "-- Вы что-то еще хотели?"
                  }
  ,dlg          = dxml "kirillov"
}

floor14_hub = engine.hub {
  enter         = choose_ {
                     ["default"] = walk_("floor14")
                    ,["med._alldone"] = walk_("end1")
                  }
}

end1 = pause {
   time         = 2000
  ,next         = "main"
}