dofile "lib/dream9.lua"

function jpg(s) 
  return const.path.gfx.."1-deadhour/night/"..s..".jpg"; 
end

main = engine.main {
   start        = chain_ {
                     episode_("1-night")
                    ,musplayer_("night_player")
                    ,walk_("street1")
                  }
  ,finish       = gamefile_("1-deadhour/clinic.lua")
}

night = engine.state {
   _brick       = false --Kate took a brick from a bench
  ,_birdshop    = false --Kate put a bird near shop
  ,_bird        = false --Kate took a bird
  ,_cops        = false --Kate saw cops
}

night_player = musplayer.player {
   sfx("bam"):inside("street1")
  ,mus("beat"):inside("copsarrive")
  ,sfx("autofocus"):inside("cop")
  ,sfx("glass"):inside("glassgood")
  ,sfx("glass"):inside("glassbad")
  ,sfx("siren"):inside("copsgood")
  ,sfx("siren"):inside("copsbad")
  ,sfx("note"):inside("exit3")
  ,mus("beat"):inside("wrong3")
}

street1 = scene {
   img          = jpg "street1"
  ,dsc          = [[Катя приехала на свою станцию незадолго до закрытия метро, а когда она уже подходила к дому, 
                    была почти половина одиннадцатого -- начался комендантский час. Кате и раньше доводилось
                    возвращаться домой поздно, поэтому она не слишком волновалась. Полицейские патрули на так
                    часто навещали их район.]]
  ,nav          = {
                     up = vw("К дому", "street2")
                    ,down = vw("В другой конец улицы", "wrong1", "night._cops", "У Кати нет никакого желания гулять по ночным улицам. Лучше вернуться домой кратчайшим путем.")
                    ,left = vw("К подъезду слева", "bench")
                    ,right = vw("К магазину справа", "shop")
                  }
}

street2 = scene {
   img          = choose_ {
                     ["default"] = jpg "street2_bird"
                    ,["night._bird"] = jpg "street2"
                  }
  ,obj          = { "bird" }
  ,nav          = {
                     left = vw("К дому", "street3_hub")
                    ,down = vw("В другой конец улицы", "street1")
                  }
}

bird = takeitem {
   nam          = "Мертвый голубь"
  ,dsc          = "Под ногами Кати лежит {мертвый голубь}. Наверное, околел от голода или болезни."
  ,inf          = "Мертвый голубь, которого Катя подобрала на улице."
  ,img          = ico "pidgeon-use"
  ,ico          = ico "pidgeon"
  ,tak          = "Превозмогая отвращение, Катя подняла труп птицы."
  ,act          = set_("night._bird")
  ,use          = chooseuse_ {
                     ["default"] = "Не стоит этого делать."
                    ,["window"] = chain_ { drop_("bird"), set_("night._birdshop"), "Катя положила труп птицы рядом с окном." }
                  }
}

street3_hub = engine.hub {
  enter         = choose_ {
                     ["default"] = walk_("copsarrive")
                    ,["street3_hub._seen"] = walk_("cop")
                  }
}

copsarrive = cutscene {
   img          = jpg "copsarrive"
  ,enter        = set_("night._cops")
  ,dsc          = [[На секунду Катя даже не поверила своим глазам. Она была всего лишь в квартале от своего дома -- в нескольких минутах
                    пути -- однако дорогу ей преграждала полицейская машина. Катя ни разу не видела ночные патрули в своем районе. 
                    Быть может, кто-то вызвал полицию? В любом случае, уезжать они явно не собирались.]]
  ,next         = "street3"
}

street3 = scene {
   img          = jpg "street3_cops"
  ,dsc          = [[Лучше отойти отсюда подальше, пока полицейские не заметили Катю. К дому можно пройти и другим путем.]]
  ,nav          = {
                     up = vw("К дому", "cop")
                    ,down = vw("В другой конец улицы", "street2")
                  }
}

bench = scene {
   img          = choose_ {
                     ["default"] = jpg "bench"
                    ,["night._brick"] = jpg "bench_broken"
                  }
  ,obj          = { "brick" }
  ,nav          = {
                    down = vw("Отойти", "street1")
                  }
}

brick = takeitem {
   nam          = "Кирпич"
  ,dsc          = "Рядом с подъездом стоит самодельная скамейка -- провисшая доска на двух массивных {кирпичах}."
  ,inf          = "Увесистый кирпич, который использовался в качестве опоры для самодельной скамейки."
  ,img          = ico "brick-use"
  ,ico          = ico "brick"
  ,tak          = chain_ { sound_("bricks"), "Катя вытащила один из кирпичей." }
  ,act          = set_("night._brick")
  ,use          = chooseuse_ {
                     ["default"] = "Не стоит этого делать."
                    ,["window"] = choose_ {
                                     ["default"] = walk_("glassbad")
                                    ,["night._birdshop"] = walk_("glassgood")
                                  }
                  }
}

shop = scene {
   img          = choose_ {
                     ["default"] = jpg "shop"
                    ,["night._birdshop"] = jpg "shop_bird"
                  }
  ,obj          = { "window" }
  ,nav          = {
                    down = vw("Отойти", "street1")
                  }
}

window = staticitem {
   dsc          = "Магазин давно закрыт, однако в {окне} все еще горит свет. Видно, хозяин забыл погасить его, когда уходил."
  ,act          = walk_("window_info")
}

window_info = cutscene {
   img          = jpg "window"
  ,dsc          = [[Катя вспомнила, как хозяин магазина хвастался, что у него стоит мощная сигнализация и, стоит кому-нибудь
                    взломать дверь или разбить окно, как всю округу огласит истошный вопль сирены.]]
  ,next         = "shop"
}

cop = cutscene {
   img          = jpg "cop"
  ,dsc          = [[Катя даже не успела понять, что произошло. Темноту вдруг прорезал ослепительный луч фонаря, а полицейский что-то
                    крикнул и предупредительно поднял руку. Бежать уже не было смысла.]]
  ,next         = "gameover"
}

glassgood = cutscene {
   img          = jpg "glass_bird"
  ,dsc          = "Катя несколько минут колебалась, но потом все же решилась. Дребезг разбитого стекла показался ей оглушительно громким."
  ,next         = "copsgood"
}

glassbad = cutscene {
   img          = jpg "glass_brick"
  ,dsc          = "Катя несколько минут колебалась, но потом все же решилась. Дребезг разбитого стекла показался ей оглушительно громким."
  ,next         = "copsbad"
}

copsgood = cutscene {
   img          = jpg "cops"
  ,dsc          = [[Сирена действительно завопила, однако быстро замолкла, точно захлебнувшись собственным криком. Полицейские
                    подъехали так быстро, что Катя едва успела укрыться. Полицейские стали рассматривать разбитое окно. Нельзя
                    было терять ни секунды.]]
  ,next         = "exit1"
}

copsbad = cutscene {
   img          = jpg "cops"
  ,dsc          = [[Сирена действительно завопила, однако быстро замолкла, точно захлебнувшись собственным криком. Полицейские
                    подъехали так быстро, что Катя едва успела укрыться. Однако полицейские недолго стояли магазина. Очень скоро они включили
                    фонари и стали прочесывать улицу.]]
  ,next         = "cop"
}

exit1 = scene {
   img          = jpg "street3"
  ,dsc          = "Нужно спешить, пока полицейские не вернулись. До дома Кати оставалось меньше квартала."
  ,nav          = {
                    up = vw("К дому", "exit2")
                  }
}

exit2 = scene {
   img          = jpg "street4"
  ,nav          = {
                    up = vw("К дому", "exit3")
                  }
}

exit3 = pause {
   time         = 5000
  ,next         = "main"
}

wrong1 = scene {
   img          = jpg "wrong1"
  ,nav          = {
                     up = fake_vw("В конец улицы", "Так до дома добраться не получится, эта улица ведет к метро.")
                    ,down = vw("По направлению к дому Кати", "street1")
                    ,left = vw("Свернуть налево", "wrong3_hub")
                    ,right = vw("Свернуть направо", "wrong2")
                  }
}

wrong2 = scene {
   img          = jpg "wrong2"
  ,dsc          = "Здесь прохода нет."
  ,nav          = {
                    down = vw("Вернуться", "wrong1")
                  }
}

wrong3_hub = engine.hub {
  enter         = choose_ {
                     ["default"] = walk_("wrong3")
                    ,["wrong3_hub._seen"] = walk_("cop")
                  }
}

wrong3 = scene {
   img          = jpg "wrong3"
  ,enter        = unlock_("night")
  ,dsc          = "Здесь еще больше полиции! Чудо, что они еще заметили Катю. Лучше побыстрее убираться отсюда."
  ,nav          = {
                     up = vw("Идти вперед", "cop")
                    ,down = vw("Вернуться", "wrong1")
                  }
}
