dofile "lib/dream9.lua"

function jpg(s) 
  return const.path.gfx.."1-deadhour/subway/"..s..".jpg"; 
end

function dxml(s)
  return const.path.dlg.."1-deadhour/subway/"..s..".xml";
end

main = engine.main {
   start        = chain_ {
                     episode_("1-subway")
                    ,musplayer_("subway_player")
                    ,walk_("intrain1")
                  }
  ,finish       = gamefile_("1-deadhour/night.lua")
}

subway = engine.state {
   _homeless    = false --Kate have spoken to a homeless guy
  ,_sickman     = false --Kate have spoken to a sick man
  ,_coin        = false --Kate have take a coin
  ,_notrains    = false --Homeless guy told Kate about trains problem
  ,_bag         = false --Kate took a bag
  ,_returned    = false --Kate returned a bag to a sick man
  ,_infopaper   = false --Kate read info paper
}

subway_player = musplayer.player {
   sfx("train"):inside("intrain1")
  ,mus("dad"):inside("station1")
  ,sfx("train_short"):inside("end1")
}

intrain1 = pause {
   time         = 2000
  ,next         = "intrain2"
}

intrain2 = tremor2 {
   img          = jpg "train"
  ,fps          = 20
  ,shift        = 20
  ,cycles       = 11
  ,next         = "intrain3"
}

intrain3 = cutscene {
   img          = jpg "traindoors"
  ,dsc          = [[Катя была так расстроена после встречи с Кочевниковым, что по ошибке села не в тот поезд. Она даже не сразу поняла, что
                    едет в противоположную сторону. Когда Катя, наконец, начала прислушиваться к объявлениям по громкоговорителю, поезд уже
                    подходил к конечной станции -- Катя приехала почти на самую окраину, к границе со старым городом.]]
  ,next         = "station1"
}

infopaper = staticitem {
   dsc          = choose_ {
                     ["default"] = "На стене висит несколько {листовок} с броским заголовком."
                    ,["loc(exit2)"] = "Вся стена здесь заклеена {листовками}."
                  }
  ,act          = chain_ { set_("subway._infopaper"), walk_("infopaper_room") }
}

infopaper_room = itemroom {
   img          = itm "infopaper3"
  ,inf          = "Оказывается, поезда по этой линии по вечерам ходят с увеличенными интервалами." 
}

exit1 = scene {
   img          = jpg "exit1"
  ,nav          = {
                     up = vw("К переходу", "exit2")
                    ,down = vw("Вернуться на станцию", "station1")
                  }
}

exit2 = scene {
   img          = jpg "exit2"
  ,obj          = { "infopaper", "homeless" }
  ,nav          = {
                     left = vw("На другую станцию", "otherstation", "subway._notrains", "Кате не нужно переходить на другую станцию.")
                    ,down = vw("Вернуться", "exit1")
                  }
}

homeless = staticitem {
   dsc          = choose_ {
                     ["default"] = "На настиле из картонных коробок, сидит {мужчина} в грязной заношенной одежде. Обычно полицейские выгоняют бездомных со станций ближе к закрытию метро."
                    ,["subway._homeless"] = "На настиле из картонных коробок, сидит {мужчина} в грязной заношенной одежде."
                  }
  ,act          = walk_("homeless_dlg")
}

homeless_dlg = dialog {
   img          = npc "homeless"
  ,dsc          = choose_ {
                     ["default"] = "Кажется, он сильно пьян -- ему даже тяжело держать голову прямо."
                    ,["not subway._homeless and not subway._notrains"] = "-- Здравствуй, красавица! Мелочи не найдется?"
                    ,["subway._notrains"] = "-- Все еще здесь? Поезда ждешь?"
                  }
  ,dlg          = dxml "homeless"
}

station1 = scene {
   img          = choose_ {
                     ["default"] = jpg "station1a"
                    ,["subway._returned"] = jpg "station1b"
                  }
  ,dsc          = [[Раньше Катя никогда не была здесь раньше. Можно подумать, что через эту станцию вообще никогда не ходят поезда.
                    Кафель на стенах облупился, повсюду валяется мусор. На станции даже нет ни одного полицейского.]]
  ,nav          = {
                     down = vw("К переходу на другую станцию", "exit1")
                    ,up = vw("В конец станции", "station2")
                    ,left = vw("На левый перрон", "left1")
                    ,right = vw("На правый перрон", "right1")
                  }
}

station2 = scene {
   img          = choose_ {
                     ["default"] = jpg "station2a"
                    ,["subway._returned"] = jpg "station2b"
                  }
  ,obj          = { "sickman" }
  ,nav          = {
                     down = vw("К переходу на другую станцию", "station1")
                    ,up = vw("В конец станции", "station3")
                    ,left = vw("На левый перрон", "left1")
                    ,right = vw("На правый перрон", "right1")
                  }
}

sickman = staticitem {
   dsc          = choose_ {
                     ["default"] = "На скамейке сидит {мужчина}. Кажется, ему плохо."
                    ,["subway._sickman"] = "На скамейке сидит {мужчина}."
                  }
  ,act          = walk_("sickman_dlg")
}

sickman_dlg = dialog {
   img          = npc "sickman"
  ,dsc          = "Мужчина точно скорчился от боли. Он смотрит перед собой неподвижным взглядом и редко, глубоко вздыхает."
  ,dlg          = dxml "sickman"
}

station3 = scene {
   img          = jpg "station3"
  ,obj          = { "phone", "infopaper" }
  ,nav          = {
                     down = vw("К переходу на другую станцию", "station2")
                    ,left = vw("На левый перрон", "left1")
                    ,right = vw("На правый перрон", "right1")
                  }
}

left1 = scene {
   img          = jpg "left1"
  ,nav          = {
                     up = vw("В конец перрона", "left2")
                    ,right = vw("В центр станции", "station2")
                  }
}

left2 = scene {
   img          = jpg "left2"
  ,dsc          = "Кто-то опрокинул мусорный бак, и весь перрон теперь завален каким-то хламом. Здесь нет ничего интересного."
  ,nav          = {
                    down = vw("Вернуться", "left1")
                  }
}

right1 = scene {
   img          = jpg "right1"
  ,nav          = {
                     up = vw("В конец перрона", "right2")
                    ,left = vw("В центр станции", "station2")
                  }
}

right2 = scene {
   img          = jpg "right2"
  ,nav          = {
                     down = vw("Вернуться", "right1")
                    ,left = vw("В туалет", "toilet")
                  }
}

toilet = scene {
   img          = choose_ {
                     ["default"] = jpg "toilet_bag"
                    ,["subway._bag"] = jpg "toilet"
                  }
  ,obj          = { "bag" }
  ,nav          = {
                    down = vw("Выйти", "right2")
                  }
}

bag = takeitem {
   nam          = "Чемодан"
  ,dsc          = "Рядом с раковиной стоит большой потертый {чемодан}."
  ,inf          = "Чемодан, который Катя нашла в туалете."
  ,img          = ico "bag-use"
  ,ico          = ico "bag"
  ,tak          = "Катя взяла чемодан."
  ,act          = set_("subway._bag")
  ,use          = chooseuse_ {
                     ["default"] = "Не стоит этого делать."
                    ,["phone"] = "Телефон и так сломан."
                    ,["sickman"] = walk_("sickman_dlg")
                  }
}

phone = staticitem {
   dsc          = "Перед Катей стоит старый, заляпанный грязью {телефонный аппарат}."
  ,act          = walk_("phone_room")
}

phone_room = itemroom {
   img          = itm "phone"
  ,obj          = { "coin" }
  ,inf          = choose_ {
                     ["default"] = "Телефон не работает -- кто-то оторвал трубку. Однако Катя замечает, что в {coin|монетоприемнике} что-то застряло."
                    ,["subway._coin"] = "Телефон не работает -- кто-то оторвал трубку."
                  }
}

coin = takeitem {
   nam          = "Монетка"
  ,inf          = "Монетка, которую Катя достала из монетоприемника сломанного телефона."
  ,img          = ico "coin-use"
  ,ico          = ico "coin"
  ,tak          = chain_ { sound_("coin"), "Катя вытащила из телефона застрявшую в нем монетку." }
  ,act          = set_("subway._coin")
  ,use          = chooseuse_ {
                     ["default"] = "В этом нет никакого смысла."
                    ,["phone"] = "Телефон не работает, позвонить все равно не получится."
                    ,["sickman"] = "Вряд ли ему нужна монетка."
                    ,["homeless"] = walk_("homeless_dlg")
                  }
}

otherstation = scene {
   img          = jpg "otherstation"
  ,dsc          = "Катя даже не очень представляет, как она поедет домой через Мещерскую."
  ,nav          = {
                    up = vw("Спуститься на станцию", "end1")
                  }
}

end1 = pause {
   time         = 3000
  ,next         = "main"
}
