dofile "lib/dream9.lua"

function jpg(s) 
  return const.path.gfx.."1-deadhour/tea/"..s..".jpg"; 
end

function dxml(s)
  return const.path.dlg.."1-deadhour/tea/"..s..".xml";
end

main = engine.main {
   start        = chain_ {
                     episode_("1-tea")
                    ,musplayer_("tea_player")
                    ,walk_("start")
                  }
  ,finish       = walk_("coridor1")
}

tea = engine.state {
   _maketea     = false --Kate want to make tea for dad
  ,_talk        = false --Kate talked with dad
  ,_pot         = "default"  --Pot is at default place
  ,_cup         = "default"  --Cup is at default place
  ,_water       = false --Water is in pot
  ,_potdone     = false --Hot water is in pot
  ,_cupdone     = false --Hot water is in cup
  ,_teadone     = false --Tea is done
  ,_body        = false --Kate found dad's body
}

tea_player = musplayer.player {
   mus("anticipation"):inside("start")
  ,mus("dad"):inside("hall"):when("tea._teadone")
  ,mute():fade(3000,3000):inside("dream1")
  ,sfx("note"):inside("wakeup")
  ,sfx("sudden"):inside("hall2")
  
  ,sfx("bam"):inside("tobecontinued")
}

start = pause {
   time         = 2000
  ,next         = "hall"
}

hall = scene {
   img          = jpg "hall"
  ,dsc          = "Вечер выдался на удивление ясный и солнечный, всю комнату заливает светом. Катя и правда начинает верить, что у них постепенно все налаживается. В новой поликлинике им обязательно помогут."
  ,obj          = { "dad" }
  ,nav          = {
                     right = vw("На кухню", "kitchen", "tea._maketea", "Делать на кухне сейчас нечего.")
                    ,left = vw("В комнату Кати", "kateroom")
                    ,down = vw("В прихожую", "coridor")
                  }
}

dad = staticitem {
   dsc          = "На диване сидит {отец}."
  ,act          = walk_("dad_dlg")
}

dad_dlg = dialog {
   nam          = "Отец"
  ,img          = npc "katedad"
  ,dsc          = "Отец сильно устал -- как и сама Катя. Они сегодня весь день провели в поликлинике."
  ,dlg          = dxml "dad"
  ,talkend      = "hall"
}

coridor = scene {
   img          = jpg "coridor"
  ,nav          = {
                     up = fake_vw("Выйти из квартиры", "Кате сейчас не хочется никуда идти.")
                    ,down = vw("В гостиную", "hall")
                    ,left = vw("В туалет", "toilet")
                  }
}

toilet = scene {
   img          = jpg "toilet"
  ,nav          = {
                    down = vw("Выйти", "coridor")
                  }
}

kateroom = scene {
   img          = jpg "room"
  ,obj          = { "sleep" }
  ,nav          = {
                    down = vw("Выйти", "hall")
                  }
}

sleep = staticitem {
   dsc          = "Хотя еще совсем рано, Катя чувствует какую-то болезненную усталость. Ей кажется, что она на ногах уже несколько дней. Катя думает, что могла бы ненадолго {прилечь} -- может, тогда ей станет лучше."
  ,cnd          = if_("tea._talk")
  ,act          = walk_("dream1")
}

kitchen = scene {
   img          = jpg "kitchen"
  ,ondrawbg     = function(s, p)
                    return s:drawtiles(p);
                  end
  ,drawtiles    = function(s, p)
                    if tea._pot=="default" or tea._pot == nil then
                      drawing.draw_pic(p, jpg "pot_default", 514, 255);
                    end
                    if tea._pot=="table" and tea._cup=="table" then
                      drawing.draw_pic(p, jpg "potcup_table", 199, 287);
                    end
                    if tea._pot=="table" and tea._cup~="table" then
                      drawing.draw_pic(p, jpg "pot_table", 199, 287);
                    end
                    if tea._pot=="plate" then
                      drawing.draw_pic(p, jpg "pot_plate", 573, 280);
                    end
                    if tea._cup=="table" and tea._pot ~="table" then
                      drawing.draw_pic(p, jpg "cup_table", 226, 330);
                    end
                    if tea._cup=="default" or tea._cup == nil then
                      drawing.draw_pic(p, jpg "cup_default", 709, 360);
                    end
                    if tea._pot=="washer" then
                      drawing.draw_pic(p, jpg "pot_washer", 388, 218);
                    end
                    return p;
                  end
  ,obj          = { "kitchen_table", "washer", "pot", "plate", "cup", "tea" }
  ,nav          = {
                    down = vw("В гостиную", "hall")
                  }
}

pot = takeitem {
   nam          = "Чайник"
  ,dsc          = choose_ {
                    ["tea._pot=='default' or tea._pot==nil"] = "Рядом с раковиной стоит {чайник}."
                  }
  ,inf          = choose_ {
                     ["default"] = "Обычный чайник со свистком."
                    ,["tea._water"] = "Чайник с водой."
                  }
  ,ico          = ico "pot"
  ,img          = ico "pot-use"
  ,tak          = "Катя взяла чайник."
  ,act          = chain_ { stop_sound, exec_("tea._pot=''") }
  ,use          = chooseuse_ {
                     ["default"] = "В этом нет никакого смысла."
                    ,["cup"] = 
                      choose_ {
                         ["default"] = "Чайник пуст."
                        ,["tea._cupdone"] = "В чашку уже налит кипяток."
                        ,["tea._water and not tea._potdone"] = "Надо бы сначала вскипятить воду."
                        ,["tea._water and tea._potdone"] = chain_ { sound_("watercup"), unset_("tea._water"), unset_("tea._potdone"), drop_("pot"), put_("pot", "kitchen"), exec_("tea._pot='plate'"), set_("tea._cupdone"), "Катя налила в чашку кипяток." }
                      }
                    ,["washer"] = 
                      choose_ {
                         ["default"] = chain_ { sound_("waterjar"), exec_("tea._pot='washer'"), set_("tea._water"), drop_("pot"), put_("pot", "kitchen"), "Катя налила воды в чайник." }
                        ,["tea._water"] = "В чайнике уже есть вода."
                      }
                    ,["plate"] = chain_ { exec_("tea._pot='plate'"), drop_("pot"), put_("pot", "kitchen"), "Катя поставила чайник на плиту. Теперь надо включить конфорку." }
                    ,["kitchen_table"] = chain_ { exec_("tea._pot='table'"), drop_("pot"), put_("pot", "kitchen"), "Катя поставила чайник на стол." }
                  }
}

cup = takeitem {
   nam          = "Чашка"
  ,dsc          = choose_ {
                    ["tea._cup=='default' or tea._cup==nil"] = "У плиты можно заметить несколько пустых банок из-под содовой и пару {чашек}."
                  }
  ,inf          = choose_ {
                     ["default"] = "Чашка для чая."
                    ,["tea._cupdone and not tea._teadone"] = "Чашка с кипятком."
                    ,["tea._teadone"] = "Чашка с чаем."
                  }
  ,ico          = ico "cup"
  ,img          = ico "cup-use"
  ,tak          = "Катя взяла чашку."
  ,act          = exec_("tea._cup=''")
  ,use          = chooseuse_ {
                     ["default"] = "В этом нет никакого смысла."
                    ,["washer"] = "Воду надо сначала вскипятить в чайнике."
                    ,["plate"] = "Вряд ли стоит ставить на плиту чашку."
                    ,["kitchen_table"] = chain_ { exec_("tea._cup='table'"), drop_("cup"), put_("cup", "kitchen"), "Катя поставила чашку на стол." }
                    ,["dad"] = 
                      choose_ {
                         ["default"] = "Чай еще не приготовлен."
                        ,["tea._teadone"] = chain_ { drop_("cup"), walk_("dad_dlg") }
                      }
                  }
}

washer = staticitem {
   dsc          = choose_ {
                     ["default"] = "В {раковине} лежит немытая посуда -- у Кати теперь даже не хватает времени на работу по дому."
                    ,["tea._pot=='washer'"] = "В {раковине} лежит немытая посуда и {pot|чайник}."
                  }
  ,act          = "Горячая вода в этом доме часто идет с перебоями, но сейчас, слава Богу, все в порядке."
}

plate = staticitem {
   dsc          = choose_ {
                     ["default"] = "Старая газовая {плита}, наверное, старше самой Кати и ее не мешало бы почистить."
                    ,["tea._pot=='plate'"] = "На {плите} стоит {pot|чайник}."
                  }
  ,act          = choose_ {
                     ["default"] = "Еще несколько лет назад муниципалитет обещал заменить все газовые плиты на электрические,^однако они до сих пор пользуются газовой плитой."
                    ,["tea._pot=='plate' and tea._potdone"] = "Катя уже вскипятила воду."
                    ,["tea._pot=='plate' and not tea._potdone and not tea._water"] = "В чайнике нет воды."
                    ,["tea._pot=='plate' and not tea._potdone and tea._water"] = walk_("kettle1")
                  }
}

kitchen_table = staticitem {
   dsc          = choose_ {
                     ["default"] = "Кухонный {столик}, где Катя обычно готовит еду и чай, совсем маленький и неудобный. Отец раньше хотел соорудить новый стол для готовки, но теперь не до этого."
                    ,["tea._pot=='table' and tea._cup~='table'"] = "На кухонном {столе} стоит {pot|чайник}."
                    ,["tea._pot=='table' and tea._cup=='table'"] = "На кухонном {столе} стоят {pot|чайник} и {cup|чашка}."
                    ,["tea._pot~='table' and tea._cup=='table'"] = "На кухонном {столе} стоит {cup|чашка}."
                  }
  ,act          = "Здесь Катя готовит еду и чай."
}

tea = takeitem {
   nam          = "Коробка с чаем"
  ,dsc          = "Однако коробки с чаем нигде не видно. Катя вспоминает, что могла положить ее в {настенный шкафчик}."
  ,inf          = "Коробка с пакетиками лечебного чая."
  ,ico          = ico "tea"
  ,img          = ico "tea-use"
  ,tak          = "Катя достала коробку с чаем из шкафчика."
  ,use          = chooseuse_ {
                     ["default"] = "В этом нет никакого смысла."
                    ,["washer"] = "Лучше не мочить чай."
                    ,["pot"] = "Чай в пакетиках, поэтому лучше сначала вскипятить воду и заварить чай уже в чашке."
                    ,["cup"] = 
                      choose_ {
                         ["default"] = "Лучше сначала налить в чашку кипяток."
                        ,["tea._cupdone"] = chain_ { sound_("teapot"), drop_("tea"), set_("tea._teadone"), "Катя положила пакетик с чаем в чашку. Напиток готов." }
                      }
                  }
}

kettle1 = pause {
   time         = 1000
  ,fading       = 50
  ,next         = "kettle2"
}

kettle2 = pause {
   time         = 5000
  ,enter        = chain_ { set_("tea._potdone"), sound_("kettle") }
  ,next         = "kettle3"
}

kettle3 = engine.hub {
  enter        = chain_ { popup_("Вода в чайнике вскипела."), walk_("kitchen") }
}

dream1 = pause {
   time         = 3000
  ,fading       = 50
  ,next         = "wakeup"
}

wakeup = cutscene {
   img          = jpg "wakeup"
  ,dsc          = [[Катя и не заметила, как провалилась в сон. Когда она проснулась, уже стояла глубокая ночь. Однако что-то было не в порядке. 
                    Настенные часы в комнате неизменно показывали без двадцати час, и казалось, что время остановилось.]]
  ,next         = "kateroom2"
}

kateroom2 = scene {
   img          = jpg "kateroom"
  ,nav          = {
                    down = vw("В гостиную", "hall2")
                  }
}

hall2 = scene {
   img          = choose_ {
                     ["default"] = jpg "body1"
                    ,["tea._body"] = jpg "body2"
                  }
  ,obj          = { "body" }
  ,nav          = {
                    down = vw("В комнату", "kateroom2")
                  }
}

body = staticitem {
   dsc          = choose_ {
                     ["default"] = "{Отец} лежит на полу."
                    ,["tea._body"] = 
                      [[-- Папа! Папа!^
                        Но отец не двигался. Катя опустилась на колени -- {пульс} не прощупывался, а кожа отца была пугающе холодной.
                      ]]
                  }
  ,act          = choose_ {
                     ["default"] = chain_ { set_("tea._body"), walk_("hall2") }
                    ,["tea._body"] = walk_("tobecontinued")
                  }
}

tobecontinued = cutscene {
   img          = const.path.gfx.."black.jpg"
  ,dsc          = "Продолжение следует..."
  ,next         = "sys_menuroom"
}