dofile "lib/dream9.lua"

function jpg(s) 
  return const.path.gfx.."1-deadhour/wake/"..s..".jpg"; 
end

function dxml(s)
  return const.path.dlg.."1-deadhour/wake/"..s..".xml";
end

wake = engine.state {
   _cup         = false --Kate removed broken cup
  ,_dad         = false --Kate saw dad
  ,_dadhelp     = false --Kate needs to help dad
  ,_drugsearch  = false --Kate looks for drugs in her room
  ,_drugfound   = false --Kate found drug
  ,_dadmoved    = false --Kate moved dad to the hall
  ,_alldone     = false --Kate did all the quests
}

wake_player = musplayer.player {
   sfx("cupsmash"):inside("wakeup")
  ,mus("clockticking"):inside("hall"):loop():always()
  ,mus("clockticking_low"):inside("coridor"):loop():always()
  ,mute():inside("kateroom"):always()
  ,mute():inside("toilet"):always()
  ,mus("dad"):inside("end1"):loop()
  ,mus("rock"):inside("end5")
}

main = engine.main {
   start        = chain_ {
                     episode_("1-wake")
                    ,musplayer_("wake_player")
                    ,walk_("wakeup")
                  }
  ,finish       = gamefile_("1-deadhour/med.lua")
}

wakeup = cutscene {
   img          = jpg "wakeup"
  ,enter        = unlock_("gamestart")
  ,dsc          = [[Катя не сразу поняла, что проснулась. По какой-то непроницаемой оглушающей тишине вокруг она догадалась,
                    что еще стоит глубокая ночь. Но спать ей больше не хотелось, ее не покидало чувство какой-то смутной тревоги. 
                    Катя встала с постели и оделась.]]
  ,next         = "kateroom"
}

kateroom = scene {
   img          = jpg "kateroom"
  ,dsc          = "На секунду Катя как будто не узнает свою комнату. Все вещи вокруг кажутся чужими."
  ,obj          = { "notebooks", "book", "computer", "clock", "look_obj", "box1", "desk", "bag", "box2", "sleep_obj" }
  ,nav          = { down = vw("Выйти из комнаты", "hall") }
}

sleep_obj = staticitem {
   dsc          = "Кате и правда нужно завтра рано вставать, однако она сомневается, что {сможет заснуть}."
  ,act          = walk_("end1")
  ,cnd          = if_("wake._alldone")
}

look_obj = staticitem {
   dsc          = "{Куда} же Катя положила эти таблетки?"
  ,act          = chain_ { set_("wake._drugsearch"), walk_("kateroom") }
  ,cnd          = if_("wake._dadhelp and not wake._drugsearch")
}

box1 = staticitem {
   dsc          = "У постели стоит {тумбочка}."
  ,act          = "Здесь мепередина нет."
  ,cnd          = if_("wake._drugsearch and not wake._drugfound")
  ,showonce     = true
}

desk = staticitem {
   dsc          = "На {столе} у Кати -- настоящий кавардак."
  ,act          = "Здесь мепередина нет."
  ,cnd          = if_("wake._drugsearch and not wake._drugfound")
  ,showonce     = true
}

bag = staticitem {
   dsc          = "Рядом со столом, у стены, -- {пластиковая сумка} из обувного магазина, с которой Катя ходит после того, как ее рюкзак порвался."
  ,act          = chain_ { take_("drug"), set_("wake._drugfound"), "Мепередин лежал в сумке, Катя даже забыла его достать. Если бы она вовремя положила^его в аптечку в туалете, то отец так бы не мучался." }
  ,cnd          = if_("wake._drugsearch and not wake._drugfound")
}

box2 = staticitem {
   dsc          = "У стены примостился старый {гардеробный шкаф}, доставшийся еще от предыдущих жильцов."
  ,act          = "Здесь мепередина нет. Вряд ли Катя положила бы его в шкаф с одеждой."
  ,cnd          = if_("wake._drugsearch and not wake._drugfound")
  ,showonce     = true
}

drug = takeitem {
   nam          = "Мепередин"
  ,ico          = ico "drug"
  ,img          = ico "drug-use"
  ,inf          = "Упаковка с таблетками мепередина - единственное обезболивающее, на которое в районной поликлинике выписали рецепт."
  ,act          = set_("wake._drugfound")
  ,use          = chooseuse_ {
                     ["default"] = "В этом нет никакого смысла."
                    ,["dad"] = walk_("dad_dlg")
                  }
}

notebooks = staticitem {
   dsc          = "На тумбочке у кровати лежат какие-то {тетради}"
  ,cnd          = not_("wake._dadhelp")
  ,act          = walk_("notebooks_room")
  ,showonce     = true
}

notebooks_room = itemroom {
   img          = itm "notebooks"
  ,inf          = "Конспекты лекций по феноменологической редукции. Из-за отца Кате часто приходится пропускать занятия. Надо не забыть вернуть конспекты Коле."
}

book = staticitem {
   dsc          = "и {книга}."
  ,cnd          = not_("wake._dadhelp")
  ,act          = walk_("book_room")
  ,showonce     = true
}

book_room = itemroom {
   img          = itm "katebook"
  ,inf          = "«Логические исследования» Эдмунда Гуссерля. В институтской лавке продавалась с большой скидкой, почти даром. Хотя сейчас бы Катя не купила ее даже за такие деньги."
}

computer = staticitem {
   dsc          = "{Компьютер} -- ровесник самой Кати. Еще лет пятнадцать назад, когда отец купил его у приятеля, он был устаревшим."
  ,cnd          = not_("wake._dadhelp")
  ,act          = walk_("computer_room")
  ,showonce     = true
}

computer_room = itemroom {
   img          = itm "oldcomputer"
  ,inf          = "Монитор давно выгорел, и на нем можно заметить контуры окна файлового менеджера."
}

clock = staticitem {
   dsc          = "{Часы} на стене давно не работают."
  ,cnd          = not_("wake._dadhelp")
  ,act          = walk_("clock_room")
  ,showonce     = true
}

clock_room = itemroom {
   img          = itm "wallclock"
  ,inf          = [[В один день часы просто остановились и перестали заводиться. Теперь они всегда показывают без двадцати час. Надо бы отнести часы в мастерскую, но на это нет ни времени, ни денег.]]
}

hall = scene {
   img          = choose_ {
                     ["default"] = jpg "hall_cup"
                    ,["not wake._dadmoved and wake._cup"] = jpg "hall"
                    ,["wake._dadmoved and wake._cup"] = jpg "hall_dad"
                    ,["wake._dadmoved and not wake._cup"] = jpg "hall_dad_cup"
                  }
  ,dsc          = choose_ {
                     ["default"] = "Свет в гостиной горит, однако отца здесь нет. Диван даже не разложен -- судя по всему, он вообще не ложился спать."
                    ,["wake._dad"] = ""
                  }
  ,alwaysdsc    = true
  ,obj          = { "cupgibs" }
  ,nav          = {
                     right = vw("В коридор", "coridor")
                    ,down = vw("В комнату Кати", "kateroom")
                  }
}

cupgibs = staticitem {
   dsc          = "На полю валяются {осколки} от разбитой чашки."
  ,act          = chain_ { remove_("cupgibs"), set_("wake._cup"), "Катя убрала осколки в мусорное ведро." }
}

coridor = scene {
   img          = choose_ {
                     ["default"] = jpg "coridor_door"
                    ,["wake._dadmoved"] = jpg "coridor"
                  }
  ,dsc          = "Дверь в уборную открыта."
  ,nav          = {
                     left = vw("В уборную", "toilet")
                    ,down = vw("В гостиную", "hall")
                    ,up   = fake_vw("Выйти из квартиры", "Зачем выходить куда-то среди ночи?")
                  }
}

toilet = scene {
   img          = choose_ {
                     ["default"] = jpg "toilet_dad"
                    ,["wake._dadmoved"] = jpg "toilet"
                  }
  ,enter        = set_("wake._dad")
  ,obj          = { "dad" }
  ,nav          = { down = vw("Выйти из уборной", "coridor") }
}

dad = staticitem {
   dsc          = choose_ {
                     ["default"] = "На полу сидит {отец} Кати."
                    ,["wake._dadmoved"] = "{Отец} сидит на диване."
                  }
  ,act          = walk_("dad_dlg")
}

dad_dlg = dialog {
   nam          = "Отец"
  ,img          = npc "katedad"
  ,dlg          = dxml "dad"
  ,dsc          = choose_ {
                     ["default"] = "Отцу даже тяжело поднять голову."
                    ,["wake._dadmoved and (wake._cup or wake._alldone)"] = "Отцу как будто и правда стало лучше."
                    ,["wake._dadmoved and not wake._cup and not wake._alldone"] = "-- Вот я криворукий! Чашку разбил. Так на меня посуды не упасешься."
                  }
}

end1 = pause {
   time         = 2000
  ,next         = "end2"
}

end2 = anitext.title {
   time         = 5000
  ,title        = "1. Мертвый час"
  ,fontsize     = 24
  ,next         = "end3"
}

end3 = cutscene {
   img          = jpg "morning"
  ,dsc          = [[-- Для тех, кто только что к нам присоединился, сообщаем -- день сегодня обещает быть холодным, температура даже в центре города
                    не будет подниматься выше 15 градусов. К тому же во второй половине дня возможны переменные осадки. Ну и как вы сами можете заметить,
                    выглянув в окно, все небо затянуто облаками -- да так, что солнце едва видно... Ну что я могу сказать, видимо, лето в этом году решило
                    завершиться раньше графика.]]
  ,next         = "end4"
}

end4 = cutscene {
   img          = jpg "morning"
  ,dsc          = [[-- Да, и если вы сегодня за рулем, имейте ввиду, что из-за серьезной аварии движение по четырнадцатой магистрали парализовано практически полностью. И, судя по всему,
                    ситуация наладится еще нескоро. Если верить навигационному спутнику, то средняя скорость машин на этом участке составляет, как вы можете
                    догадаться, ноль километров в час... Но достаточно о грустном. Холод и пробки -- вовсе не повод для плохого настроения. Напоминаем, что 
                    после выпуска новостей, к нам придет в гости Николай Шмидт. А пока -- немного бодрых миксов...]]
  ,next         = "end5"
}

end5 = pause {
   img          = jpg "morning"
  ,time         = 8000
  ,dsc          = "-- Вы слушаете Новое Радио, волну 74.3!"
  ,next         = "main"
}