-- Codename Dream9 by Basil Voronkov
-- Module 'activeitem'
---------------------------------------------
-- This module implements an active item concept
-- by providing a room that can display an active
-- item and functions that can be used to deal with it.
require "lib/drawing"
require "lib/const"

activeitem = {
  defaults = {
    itemx = const.hudx,
    itemy = 87,
  }
}

function activeitem.set(o)
  local nm = deref_if(o);
  _activeitem = o;
end

function activeitem.clear()
  _activeitem = nil;
end

function activeitem.room(o)
  local ondrawbg = o.ondrawbg;
  o.ondrawbg2   = function(s, p)
                    if ondrawbg ~= nil then
                      ondrawbg(s, p);
                    end
                    if _activeitem ~= nil then
                      local ai = ref(_activeitem);
                      drawing.draw_pic(p, ai.img, activeitem.defaults.itemx, activeitem.defaults.itemy);
                    end
                    return p;
                  end
  return o;
end