-- Codename Dream9 by Basil Voronkov
-- Module 'const'
---------------------------------------------
-- Contains useful constant for the game engine.

const = {}

const.path = {
  theme = "theme/",
  gfx = "gfx/",
  ui = "gfx/ui/",
  achiv = "gfx/achiv/",
  ico = "gfx/ico/",
  mus = "mus/",
  sfx = "sfx/",
  game = "game/",
  dlg = "dlg/"
}

--Generic drawing constants
const.font = "sans.ttf";
const.fontb = "sans-b.ttf";
const.fontem = "sans-em.ttf";
const.fontsize = 12;

const.opacity = 150;
const.maskcolor = "black";
const.selcolor = "red";
const.textcolor = "white";
const.linkcolor = "cyan";
const.activelinkcolor = "#FFCC66";

--Scene related constants
const.scenefont = const.font;
const.scenefontsize = 14;
const.winwidth = 960;
const.winheight = 600;
const.picwidth = const.winwidth;
const.picheight = 560;
const.blackbar = (const.winheight - const.picheight)/2;
const.dscpad = 20;
const.textwidth = const.winwidth - const.dscpad*2;
const.dscframepadx = 11;
const.dscframepady = 4;
const.textframewidth = const.winwidth - const.dscframepadx*2;

--Hud
const.hudx = 890;
const.hudy = 15;

--Theme related
const.invx = 3;
const.invy = 3;
const.menubuttonx = const.winwidth - 24;
const.menubuttony = 0;
const.menupad = 10;
const.textalign = "left";
const.cursor = "theme/cursor.png";
const.cursorx = 2;
const.cursory = 2;
const.clicksnd = "theme/click.wav";
const.menufontsize = 15;
const.menubutton = "theme/menu.png";

--Application of parameters
theme.set("menu.button.x", const.menubuttonx);
theme.set("menu.button.y", const.menubuttony);
theme.set("menu.col.bg", "black");
theme.set("menu.col.fg",  const.textcolor);
theme.set("menu.col.link", const.linkcolor);
theme.set("menu.col.alink", const.activelinkcolor);
theme.set("menu.col.alpha", const.opacity);
theme.set("menu.col.border", "black");
theme.set("menu.bw", 2)
theme.set("menu.fnt.size", const.menufontsize);
theme.set("menu.fnt.height", "1.0");
theme.set("menu.gfx.button", const.menubutton);
theme.set("inv.x", const.invx);
theme.set("inv.y", const.invy);
theme.set("inv.w", const.picwidth - 50);
theme.set("inv.h", const.blackbar);
theme.set("inv.mode", "horizontal-left");
theme.set("inv.up.x", -1);
theme.set("inv.up.y", -1);
theme.set("inv.down.x", -1);
theme.set("inv.down.y", -1);
theme.set("inv.col.link", const.textcolor);
theme.set("inv.col.alink", const.activelinkcolor);
theme.set("inv.fnt.size", const.fontsize);
theme.set("inv.fnt.height", 1.0);
theme.set("scr.w", const.winwidth);
theme.set("scr.h", const.winheight);
theme.set("scr.gfx.scalable", 0);
theme.set("scr.gfx.bg", "theme/bg.png");
theme.set("scr.col.bg", "white");
theme.set("scr.gfx.pad", const.menupad);
theme.set("scr.gfx.mode", "float");
theme.set("scr.gfx.x", 0);
theme.set("scr.gfx.y", const.blackbar);
theme.set("scr.gfx.w", const.picwidth);
theme.set("scr.gfx.h", 100); --changed dynamically
theme.set("win.align", const.textalign);
theme.set("win.x", const.blackbar);
theme.set("win.y", 300); --changed dynamically
theme.set("win.w", const.winwidth); --changed dynamically
theme.set("win.h", 100); --changed dynamically
theme.set("scr.gfx.cursor.x", const.cursorx);
theme.set("scr.gfx.cursor.y", const.cursory);
theme.set("scr.gfx.cursor.normal", const.cursor);
theme.set("win.fnt.size", const.scenefontsize);
theme.set("win.fnt.height", 1.0);
theme.set("win.col.fg", const.textcolor);
theme.set("win.col.link", const.linkcolor);
theme.set("win.col.alink", const.activelinkcolor);
theme.set("win.up.x", -1);
theme.set("win.up.y", -1);
theme.set("win.down.x", -1);
theme.set("win.down.y", -1);
theme.set("snd.click", const.clicksnd);
theme.set("win.gfx.up", "theme/aup.png");
theme.set("win.gfx.down", "theme/adown.png");