-- Codename Dream9 by Basil Voronkov
-- Module 'dream9'
---------------------------------------------
-- This is an 'includes' module. It includes all
-- the modules from the game engine, so that you can include
-- only this file.

--Instead modules
require "xact"
require "hideinv"
require "para"
require "dash"
require "quotes"
require "sprites"
require "theme"
require "timer"
require "click"

--Engine modules
require "lib/util"
require "lib/engine"
require "lib/tact"
require "lib/popup"
require "lib/rooms"
require "lib/dialog"
require "lib/inventory"
require "lib/musplayer"
require "lib/anitext"
require "lib/navigation"
require "lib/achievement"
require "lib/mainmenu"
require "lib/episodes"

function ico(s)
  return const.path.gfx.."icons/"..s..".png"; 
end

function npc(s)
  return const.path.gfx.."npc/"..s..".png";
end

function itm(s)
  return const.path.gfx.."items/"..s..".png"; 
end

------------------------------------------------------------------------
--Inits
dream9 = {}

function dream9.init()
  format.para_space = "";  
  click.button = true;
  
  drawing.init();
  tact.init();
  musplayer.init();
  dia.init();
  inventory.init();
  popup.init();
  rooms.init();
  achievement.init();
  mainmenu.init();
  episodes.init();
end

dream9.init();

------------------------------------------------------------------------
--Debug

debug_object = obj {
 nam = function()
  return tostring(escape._life);
 end
}
